PostgreSQL 7.1.3 Documentation
Prev |  | Next

# SPI_prepare

## Name

SPI_prepare -- Connects your procedure to the SPI manager.

## Synopsis

    SPI_prepare(query, nargs, argtypes)

### Inputs

`query`

  Query string

`nargs`

  Number of input parameters ($1 ... $nargs - as in SQL-functions)

`argtypes`

  Pointer list of type OIDs to input arguments

### Outputs

void *

  Pointer to an execution plan (parser+planner+optimizer)

## Description

`SPI_prepare` creates and returns an execution plan (parser+planner+optimizer) but doesn't execute the query. Should only be called from a connected procedure.

## Usage

nargs is number of parameters ($1 ... $nargs - as in SQL-functions), and nargs may be 0 only if there is not any $1 in query.

Execution of prepared execution plans is sometimes much faster so this feature may be useful if the same query will be executed many times.

The plan returned by `SPI_prepare` may be used only in current invocation of the procedure since `SPI_finish` frees memory allocated for a plan. See `SPI_saveplan`.

If successful, a non-null pointer will be returned. Otherwise, you'll get a NULL plan. In both cases SPI_result will be set like the value returned by SPI_exec, except that it is set to SPI_ERROR_ARGUMENT if query is NULL or nargs < 0 or nargs > 0 && argtypes is NULL.

Prev | Home | Next
SPI_exec | Up | SPI_saveplan